' KEYTEST1 - Tests the low level keyboard handler.
'
' By Gary Neal, Jr. -- http://garyneal.tripod.com/

DECLARE FUNCTION KeyHardAborted% ()
DECLARE FUNCTION KeyPressedNow% (scanCode AS INTEGER)
DECLARE FUNCTION KeyPressed% (scanCode AS INTEGER)
DECLARE SUB InitializeKeyISRCode ()
DECLARE SUB InstallKeyISR (chaining AS INTEGER)
DECLARE SUB RemoveKeyISR ()

CONST TRUE = -1
CONST FALSE = NOT TRUE

' Array size must be >= (keyboard.bin file size) / 2 + 1
' Do not load keyboard.bin into a string variable.
' Code contained in keyboard.bin MUST be paragraph aligned.
DIM SHARED KeyISRCode(0 TO 378) AS INTEGER
DIM SHARED KeyISRCodeInitialized AS INTEGER

DIM X AS INTEGER, Y AS INTEGER

InitializeKeyISRCode

SCREEN 13

X = 160
Y = 100

InstallKeyISR FALSE

DO UNTIL KeyPressed%(1) OR KeyHardAborted%
    PSET (X, Y), 0

    IF KeyPressedNow%(72) THEN
        Y = Y - 1
        IF Y < 0 THEN Y = 0
    ELSEIF KeyPressedNow%(80) THEN
        Y = Y + 1
        IF Y > 199 THEN Y = 199
    END IF

    IF KeyPressedNow%(75) THEN
        X = X - 1
        IF X < 0 THEN X = 0
    ELSEIF KeyPressedNow%(77) THEN
        X = X + 1
        IF X > 319 THEN X = 319
    END IF

    PSET (X, Y), 15

    ' If dot moves too slowly, change the 1000 to a smaller number.
    ' If dot moves too quickly, increase the 1000 to a larger number.
    FOR delay = 1 TO 1000: NEXT delay
LOOP

RemoveKeyISR

END

SUB InitializeKeyISRCode
    DIM X AS INTEGER

    OPEN "keyboard.bin" FOR BINARY ACCESS READ AS #1
    FOR X = 0 TO UBOUND(KeyISRCode)
        GET #1, , KeyISRCode(X)
    NEXT X

    KeyISRCodeInitialized = TRUE
END SUB

SUB InstallKeyISR (chaining AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(chaining, KeyISRCode(0))
    DEF SEG
END SUB

' KeyHardAborted%
'
' This function returns TRUE (-1) if user presses CTRL-ALT-DEL or
' CTRL-ALT-END while the low level keyboard handler is engaged.
'
FUNCTION KeyHardAborted%
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, KeyISRCode(4))
    DEF SEG
    KeyHardAborted% = retVal
END FUNCTION

FUNCTION KeyPressed% (scanCode AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, scanCode, KeyISRCode(2))
    DEF SEG
    KeyPressed% = retVal
END FUNCTION

FUNCTION KeyPressedNow% (scanCode AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, scanCode, KeyISRCode(3))
    DEF SEG
    KeyPressedNow% = retVal
END FUNCTION

SUB RemoveKeyISR
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(KeyISRCode(1))
    DEF SEG
END SUB

