' KEYTEST2 - Tests the extended key functionality.
'
' By Gary Neal, Jr. -- http://garyneal.tripod.com/

DECLARE FUNCTION KeyHardAborted% ()
DECLARE FUNCTION KeyPressedNow% (scanCode AS INTEGER)
DECLARE FUNCTION KeyPressed% (scanCode AS INTEGER)
DECLARE SUB InitializeKeyISRCode ()
DECLARE SUB InstallKeyISR (chaining AS INTEGER)
DECLARE SUB RemoveKeyISR ()

CONST TRUE = -1
CONST FALSE = NOT TRUE

' Array size must be >= (keyboard.bin file size) / 2 + 1
' Do not load keyboard.bin into a string variable.
' Code contained in keyboard.bin MUST be paragraph aligned.
DIM SHARED KeyISRCode(0 TO 378) AS INTEGER
DIM SHARED KeyISRCodeInitialized AS INTEGER

InitializeKeyISRCode

InstallKeyISR FALSE

PRINT "Press either the enter key on keyboard or numeric keypad."
PRINT "Press ESC to quit."

DO UNTIL KeyHardAborted% OR KeyPressedNow%(1)
    IF KeyPressed%(&H1C) = 128 THEN
        PRINT "Enter key on numeric keypad is pressed."
    ELSEIF KeyPressed%(&H1C) = 1 THEN
        PRINT "Enter key on keyboard is pressed."
    ELSEIF KeyPressed%(&H1C) = 129 THEN
        PRINT "Both ENTER keys pressed."
    END IF
LOOP

PRINT
PRINT "Removing low level keyboard handler..."

RemoveKeyISR

END

SUB InitializeKeyISRCode
    DIM X AS INTEGER

    OPEN "keyboard.bin" FOR BINARY ACCESS READ AS #1
    FOR X = 0 TO UBOUND(KeyISRCode)
        GET #1, , KeyISRCode(X)
    NEXT X

    KeyISRCodeInitialized = TRUE
END SUB

SUB InstallKeyISR (chaining AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(chaining, KeyISRCode(0))
    DEF SEG
END SUB

' KeyHardAborted%
'
' This function returns TRUE (-1) if user presses CTRL-ALT-DEL or
' CTRL-ALT-END while the low level keyboard handler is engaged.
'
FUNCTION KeyHardAborted%
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, KeyISRCode(4))
    DEF SEG
    KeyHardAborted% = retVal
END FUNCTION

FUNCTION KeyPressed% (scanCode AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, scanCode, KeyISRCode(2))
    DEF SEG
    KeyPressed% = retVal
END FUNCTION

FUNCTION KeyPressedNow% (scanCode AS INTEGER)
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DIM retVal AS INTEGER
    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(retVal, scanCode, KeyISRCode(3))
    DEF SEG
    KeyPressedNow% = retVal
END FUNCTION

SUB RemoveKeyISR
    IF NOT KeyISRCodeInitialized THEN
        InitializeKeyISRCode
    END IF

    DEF SEG = VARSEG(KeyISRCode(0))
    CALL Absolute(KeyISRCode(1))
    DEF SEG
END SUB

